#
# Copyright (c) 2016 Sam4Mobile, 2017 Make.org
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# This recipe will be in charge of the creation of needed files
# for cockroachdb testing through kitchen.

cockroachdb_home = node['cockroachdb-platform']['prefix_home']

directory 'cert directory' do
  path "#{cockroachdb_home}/cockroachdb/certs"
  owner node['cockroachdb-platform']['user']
  group node['cockroachdb-platform']['group']
  recursive true
end

%w[client.root.crt client.root.key].each do |cert|
  cookbook_file "#{cockroachdb_home}/cockroachdb/certs/#{cert}" do
    source cert
    owner node['cockroachdb-platform']['user']
    group node['cockroachdb-platform']['group']
    mode '0600'
    action :create
  end
end
